unit DXFReadForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ClipBrd, 
  DXFReadWrite, DXF2CADSYS, Obj2D, Prim2D, ViewPanel, CAD2DCmp, GrLib2D, Block2D,
  Menus;

type
  TForm1 = class(TForm)
    CADCmp1: TCADCmp;
    ViewportPanel1: TViewportPanel;
    Panel1: TPanel;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    ImportDXF1: TMenuItem;
    N1: TMenuItem;
    Savefile1: TMenuItem;
    Loadfile1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    Showgrid1: TMenuItem;
    Fastrepaint1: TMenuItem;
    Label1: TLabel;
    ListBox1: TListBox;
    SaveDialog1: TSaveDialog;
    OpenDialog2: TOpenDialog;
    Copy1: TMenuItem;
    procedure ImportDXF1Click(Sender: TObject);
    procedure Savefile1Click(Sender: TObject);
    procedure Loadfile1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Showgrid1Click(Sender: TObject);
    procedure Fastrepaint1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    TmpDXF: TDXFImport;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.ImportDXF1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
   begin
     ViewportPanel1.WhereToDraw := [wdOffScreen];
     Screen.Cursor := crHourGlass;
     try
       TmpDXF := TDXFImport.Create(OpenDialog1.FileName, CADCmp1);
       try
         TmpDXF.ReadDXF;
         ListBox1.Items.AddStrings(TmpDXF.LayerList);
         ViewportPanel1.Extensions := TmpDXF.Extension;
         ViewportPanel1.WhereToDraw := [wdOffScreen, wdCanvas];
         ViewportPanel1.ZoomAllClick(Self);
       finally
         TmpDXF.Free;
       end;
     finally
       Screen.Cursor := crDefault;
     end;
   end;
end;

procedure TForm1.Savefile1Click(Sender: TObject);
var
  TmpStream: TFileStream;
begin
  if SaveDialog1.Execute then
   begin
     TmpStream := TFileStream.Create(SaveDialog1.FileName, fmOpenWrite or fmCreate);
     try
       Screen.Cursor := crHourGlass;
       CADCmp1.SaveToStream(TmpStream);
     finally
       TmpStream.Free;
       Screen.Cursor := crDefault;
     end;
   end;
end;

procedure TForm1.Loadfile1Click(Sender: TObject);
var
  TmpStream: TFileStream;
begin
  if OpenDialog2.Execute then
   begin
     TmpStream := TFileStream.Create(OpenDialog2.FileName, fmOpenRead);
     try
       Screen.Cursor := crHourGlass;
       CADCmp1.LoadFromStream(TmpStream);
       Viewportpanel1.Extensions := CADCmp1.WorldExtension;
       ViewportPanel1.ZoomAllClick(Self);
     finally
       TmpStream.Free;
       Screen.Cursor := crDefault;
     end;
   end;
end;

procedure TForm1.Copy1Click(Sender: TObject);
var
  TmpBmp: TBitmap;
begin
  TmpBmp := TBitmap.Create;
  try
    TmpBmp.Width := 200;
    TmpBmp.Height := 200;
    with ViewportPanel1.Viewport do
     begin
       ViewportPanel1.BackGroundColor := clWhite;
       CopyOnCanvas(TmpBmp.Canvas, cmExtensions, 1.0, 1.0);
       ViewportPanel1.BackGroundColor := clSilver;
     end;
     Clipboard.Assign(TmpBmp);
  finally
    TmpBmp.Free;
  end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.Showgrid1Click(Sender: TObject);
begin
  ShowGrid1.Checked := not ShowGrid1.Checked;
  if ShowGrid1.Checked then
   ViewportPanel1.Viewport.GridStep := Point2D(10, 10)
  else
   ViewportPanel1.Viewport.GridStep := Point2D(0, 0);
  ViewportPanel1.Viewport.Repaint;
end;

procedure TForm1.Fastrepaint1Click(Sender: TObject);
begin
  FastRepaint1.Checked := not FastRepaint1.Checked;
  if FastRepaint1.Checked then
   MIN_BOX_FILL := 8
  else
   MIN_BOX_FILL := -1;
  ViewportPanel1.Viewport.Repaint;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var
  TmpStr: String;
  TmpInt: Integer;
begin
  TmpInt := ListBox1.ItemIndex;
  TmpStr := ListBox1.Items[TmpInt];
  if TmpStr[1] = '-' then
   begin
     Delete(TmpStr, 1, 1);
     CADCmp1.Layers[TmpInt].Active := True;
   end
  else
   begin
     Insert('-', TmpStr, 1);
     CADCmp1.Layers[TmpInt].Active := False;
   end;
  ListBox1.Items[TmpInt] := TmpStr;
  ListBox1.ItemIndex := TmpInt;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  MIN_BOX_FILL := 8
end;

end.
